/*
 *                              E R R O R . C
 */

/*)LIBRARY
*/

#ifdef  DOCUMENTATION

title   error   Fatal Error Exit
index           Fatal Error Exit

synopsis

         error(fmt, arg1, arg2, ...)
         char   *fmt;
         <any>  arg1;
         <any>  arg2; ...
description

        Print an error message to stderr and then abort execution.  The
        arguments to error are passed on to fprintf(), so that a message
        is printed as if

                fprintf(stderr, fmt, arg1, arg2, ...);

        had been executed.  Then a fatal error is signaled with LIB$STOP.
        If errno is 0, the fatal error is SS$_ABORT; otherwise, perror()
        is called as:

                    perror("Fatal error");

        to display the C error message corresponding to errno, and then
        the error stored in vaxc$errno is signalled with LIB$STOP.

bugs

        There can be no more than 8 arguments to the format string; any
        extras are ignored with no warning.

author

        Martin Minow

#endif

/*
 * Edit history
 * 0.0 ??-???-??  MM    Invention
 */

#include <stdio.h>
#include <ssdef.h>

#ifdef OLD_BUT_DOESNT_WORK_NOW

/*
 * In older versions of VAX C, it was possible to call c$$doprint directly,
 * effectively passing on an arbitrary number of parameters.  In VAX C V2.0
 * this doesn't work correctly, causing link-time errors.
 */
error(fmt, args)
char            *fmt;
int             args;
/*
 * A fatal error has occurred.
 */
{
        c$$doprint(stderr, fmt, &args);
        lib$stop(SS$_ABORT);
}

#else

/*
 * Do it the limited but "honest" way.
 */
#include <errno.h>

error(fmt, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8)
char    *fmt;
{
        fprintf(stderr, fmt, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8);
        if (errno) {
            perror("Fatal error");
            LIB$STOP(vaxc$errno);
        }
        else {
            LIB$STOP(SS$_ABORT);
        }
}

#endif
